Index: channels/chan_sip.c
===================================================================
--- channels/chan_sip.c	(revision 333496)
+++ channels/chan_sip.c	(working copy)
@@ -4662,6 +4662,7 @@
 	/* First check on peer name */
 	if (newpeername) {
 		if (realtimeregs)
+			/* LEAK #1-a: if sippeer is not found soon, this will leak */
 			varregs = ast_load_realtime("sipregs", "name", newpeername, SENTINEL);
 
 		var = ast_load_realtime("sippeers", "name", newpeername, "host", "dynamic", SENTINEL);
@@ -4709,6 +4710,7 @@
 			}
 		} else {
 			if (realtimeregs)
+				/* LEAK #1-b: if sippeer is not found soon, this will leak */
 				varregs = ast_load_realtime("sipregs", "ipaddr", ipaddr, "port", portstring, SENTINEL); /* Then check for registered hosts */
 			else
 				var = ast_load_realtime("sippeers", "ipaddr", ipaddr, "port", portstring, SENTINEL); /* Then check for registered hosts */
@@ -4724,9 +4726,11 @@
 				if(var) {
 					if (realtimeregs) {
 						newpeername = get_name_from_variable(var, newpeername);
+						/* LEAK #2-a: this will always leak because peerlist is non-zero */
 						varregs = ast_load_realtime("sipregs", "name", newpeername, SENTINEL);
 					}
 				} else { /*var wasn't found in the list of "hosts", so try "ipaddr"*/
+					/* LEAK #3: leaking peerlist, peerlist was non-zero */
 					peerlist = NULL;
 					peerlist = ast_load_realtime_multientry("sippeers", "ipaddr", ipaddr, SENTINEL);
 					if(peerlist) {
@@ -4734,6 +4738,7 @@
 						if(var) {
 							if (realtimeregs) {
 								newpeername = get_name_from_variable(var, newpeername);
+								/* LEAK #2-b: this will always leak because peerlist is non-zero */
 								varregs = ast_load_realtime("sipregs", "name", newpeername, SENTINEL);
 							}
 						}
@@ -4746,6 +4751,7 @@
 						varregs = get_insecure_variable_from_config(peerlist);
 						if (varregs) {
 							newpeername = get_name_from_variable(varregs, newpeername);
+							/* LEAK #2-c: this will always leak because peerlist is non-zero */
 							var = ast_load_realtime("sippeers", "name", newpeername, SENTINEL);
 						}
 					}
@@ -4755,6 +4761,8 @@
 						var = get_insecure_variable_from_config(peerlist);
 						if (var) {
 							newpeername = get_name_from_variable(var, newpeername);
+							/* LEAK #2-d: this will always leak because peerlist is non-zero */
+							/* BUT.. this cannot succeed, because realtimeregs is 0: sipregs does not exist */
 							varregs = ast_load_realtime("sipregs", "name", newpeername, SENTINEL);
 						}
 					}
